package org.xbib.event.async.io;

import org.reactivestreams.Subscription;

/**
 * For subscribers pipeline composition.
 * This should the leaf of the pipeline.
 * This avoids to check if next is null.
 *
 * @param <T>
 */
public class EmptySubscriber<T> implements org.reactivestreams.Subscriber<T> {

    public EmptySubscriber() {
    }

    @Override
    public void onSubscribe(Subscription subscription) {
    }

    @Override
    public void onNext(T t) {
    }

    @Override
    public void onError(Throwable throwable) {
    }

    @Override
    public void onComplete() {
    }
}
