package org.xbib.event.async.yield.async;

import org.xbib.event.async.yield.AsyncQuery;

import java.util.HashSet;
import java.util.concurrent.CompletableFuture;
import java.util.function.BiConsumer;

public class AsyncQueryDistinct<T> extends AsyncQuery<T> {

    private final AsyncQuery<T> upstream;

    public AsyncQueryDistinct(AsyncQuery<T> upstream) {
        this.upstream = upstream;
    }

    @Override
    public CompletableFuture<Void> subscribe(BiConsumer<? super T, ? super Throwable> cons) {
        final HashSet<T> mem = new HashSet<>();
        return upstream.subscribe((item, err) -> {
            if (err != null) {
                cons.accept(null, err);
                return;
            }
            if (mem.add(item)) cons.accept(item, null);
        });
    }
}
