package org.xbib.event.async.yield.async;

import org.xbib.event.async.yield.AsyncQuery;
import org.xbib.event.async.yield.Query;

import java.util.concurrent.CompletableFuture;
import java.util.function.BiConsumer;

import static java.util.concurrent.CompletableFuture.runAsync;

public class AsyncQueryFork<U> extends AsyncQuery<U> {

    private final U[] data;

    public AsyncQueryFork(U[] data) {
        this.data = data;
    }

    @Override
    public CompletableFuture<Void> subscribe(BiConsumer<? super U, ? super Throwable> cons) {
        return runAsync(() -> Query
                .of(data)
                .traverse(item -> cons.accept(item, null)));
    }
}
