package org.xbib.event.async.yield.ops;

import org.xbib.event.async.yield.Advancer;
import org.xbib.event.async.yield.Query;
import org.xbib.event.async.yield.Traverser;
import org.xbib.event.async.yield.Yield;

import java.util.function.Consumer;

public class Peek<T> implements Advancer<T>, Traverser<T> {

    private final Query<T> upstream;

    private final Consumer<? super T> action;

    public Peek(Query<T> adv, Consumer<? super T> action) {
        this.upstream = adv;
        this.action = action;
    }

    @Override
    public void traverse(Yield<? super T> yield) {
        upstream.traverse(item -> {
            action.accept(item);
            yield.ret(item);
        });
    }

    @Override
    public boolean tryAdvance(Yield<? super T> yield) {
        return upstream.tryAdvance(item -> {
            action.accept(item);
            yield.ret(item);
        });
    }
}
