package org.xbib.event.async.yield.primitives.dbl.ops;

import org.xbib.event.async.yield.primitives.dbl.DoubleAdvancer;
import org.xbib.event.async.yield.primitives.dbl.DoubleQuery;
import org.xbib.event.async.yield.primitives.dbl.DoubleTraverser;
import org.xbib.event.async.yield.primitives.dbl.DoubleYield;

import java.util.function.DoubleConsumer;

public class DoublePeek implements DoubleAdvancer, DoubleTraverser {

    private final DoubleQuery upstream;

    private final DoubleConsumer action;

    public DoublePeek(DoubleQuery adv, DoubleConsumer action) {
        this.upstream = adv;
        this.action = action;
    }

    @Override
    public void traverse(DoubleYield yield) {
        upstream.traverse(item -> {
            action.accept(item);
            yield.ret(item);
        });
    }

    @Override
    public boolean tryAdvance(DoubleYield yield) {
        return upstream.tryAdvance(item -> {
            action.accept(item);
            yield.ret(item);
        });
    }
}
