package org.xbib.event.async.yield.primitives.dbl.ops;

import org.xbib.event.async.yield.Yield;
import org.xbib.event.async.yield.boxes.BoolBox;
import org.xbib.event.async.yield.primitives.dbl.DoubleAdvancer;
import org.xbib.event.async.yield.primitives.dbl.DoubleQuery;
import org.xbib.event.async.yield.primitives.dbl.DoubleTraverser;
import org.xbib.event.async.yield.primitives.dbl.DoubleYield;

import java.util.function.DoubleBinaryOperator;

public class DoubleZip implements DoubleAdvancer, DoubleTraverser {

    private final DoubleQuery upstream;

    private final DoubleQuery other;

    private final DoubleBinaryOperator zipper;

    public DoubleZip(DoubleQuery upstream, DoubleQuery other, DoubleBinaryOperator zipper) {
        this.upstream = upstream;
        this.other = other;
        this.zipper = zipper;
    }

    @Override
    public void traverse(DoubleYield yield) {
        upstream.shortCircuit(e1 -> {
            if (!other.tryAdvance(e2 -> yield.ret(zipper.applyAsDouble(e1, e2))))
                Yield.bye();
        });
    }

    @Override
    public boolean tryAdvance(DoubleYield yield) {
        BoolBox consumed = new BoolBox();
        upstream.tryAdvance(e1 -> other.tryAdvance(e2 -> {
            yield.ret(zipper.applyAsDouble(e1, e2));
            consumed.set();
        }));
        return consumed.isTrue();
    }
}
