package org.xbib.event.async.yield.primitives.dbl.ops;

import org.xbib.event.async.yield.primitives.dbl.DoubleAdvancer;
import org.xbib.event.async.yield.primitives.dbl.DoubleTraverser;
import org.xbib.event.async.yield.primitives.dbl.DoubleYield;

import java.util.Spliterator;
import java.util.function.DoubleConsumer;
import java.util.stream.DoubleStream;

public class FromDoubleStream implements DoubleAdvancer, DoubleTraverser {

    private final Spliterator.OfDouble upstream;

    public FromDoubleStream(DoubleStream data) {
        this.upstream = data.spliterator();
    }

    @Override
    public void traverse(DoubleYield yield) {
        DoubleConsumer cons = yield::ret;
        upstream.forEachRemaining(cons);
    }

    @Override
    public boolean tryAdvance(DoubleYield yield) {
        DoubleConsumer cons = yield::ret;
        return upstream.tryAdvance(cons);
    }
}
