package org.xbib.event.async.yield.primitives.intgr.ops;

import org.xbib.event.async.yield.primitives.intgr.IntAdvancer;
import org.xbib.event.async.yield.primitives.intgr.IntQuery;
import org.xbib.event.async.yield.primitives.intgr.IntTraverser;
import org.xbib.event.async.yield.primitives.intgr.IntYield;

import java.util.function.IntUnaryOperator;

public class IntMapping implements IntAdvancer, IntTraverser {

    private final IntQuery upstream;
    private final IntUnaryOperator mapper;

    public IntMapping(IntQuery adv, IntUnaryOperator mapper) {
        this.upstream = adv;
        this.mapper = mapper;
    }

    @Override
    public void traverse(IntYield yield) {
        upstream.traverse(e -> yield.ret(mapper.applyAsInt(e)));
    }

    @Override
    public boolean tryAdvance(IntYield yield) {
        return upstream.tryAdvance(item -> yield.ret(mapper.applyAsInt(item)));
    }
}
