package org.xbib.event.async.yield.primitives.lng.ops;

import org.xbib.event.async.yield.primitives.lng.LongAdvancer;
import org.xbib.event.async.yield.primitives.lng.LongQuery;
import org.xbib.event.async.yield.primitives.lng.LongTraverser;
import org.xbib.event.async.yield.primitives.lng.LongYield;

import java.util.function.LongUnaryOperator;

public class LongMap implements LongAdvancer, LongTraverser {

    private final LongQuery upstream;
    private final LongUnaryOperator mapper;

    public LongMap(LongQuery adv, LongUnaryOperator mapper) {
        this.upstream = adv;
        this.mapper = mapper;
    }

    @Override
    public void traverse(LongYield yield) {
        upstream.traverse(e -> yield.ret(mapper.applyAsLong(e)));
    }

    @Override
    public boolean tryAdvance(LongYield yield) {
        return upstream.tryAdvance(item -> yield.ret(mapper.applyAsLong(item)));
    }
}
