package org.xbib.event.log;

import java.io.IOException;
import java.io.OutputStream;

public class ByteCountingOutputStream extends OutputStream {

    private final OutputStream outputStream;

    private long size;

    public ByteCountingOutputStream(OutputStream outputStream, long size) {
        this.outputStream = outputStream;
        this.size = size;
    }

    public long size() {
        return size;
    }

    @Override
    public void write(int b) throws IOException {
        outputStream.write(b);
        size++;
    }

    @Override
    public void write(byte[] b) throws IOException {
        outputStream.write(b);
        size += b.length;
    }

    @Override
    public void write(byte[] b, int off, int len) throws IOException {
        outputStream.write(b, off, len);
        size += len;
    }

    @Override
    public void flush() throws IOException {
        outputStream.flush();
    }

    @Override
    public void close() throws IOException {
        outputStream.close();
    }
}
