package org.xbib.event.persistence;

import java.io.IOException;
import java.util.Map;

public interface PersistenceStore<K, V> {

    Durability getDurability();

    Codec<Map<K, V>> getCodec();

    void insert(K k, V v) throws IOException;

    boolean remove(K k, V v) throws IOException;

    Object get(String key);

    Object getOrDefault(String key, Object defaultValue);

    void load() throws IOException;

    void begin();

    void commit() throws IOException;

    void rollback();

    void clear();
}
