package org.xbib.event.wal;

import java.io.File;
import java.util.Collections;
import java.util.Map;
import java.util.Set;

public interface SnapshotRecovery<T> {
    long getMaxTransactionId();

    Map<Object, T> getRecords();

    Set<String> getRecoveredSwapLocations();

    File getRecoveryFile();


    public static <T> SnapshotRecovery<T> emptyRecovery() {
        return new SnapshotRecovery<T>() {
            @Override
            public long getMaxTransactionId() {
                return -1L;
            }

            @Override
            public Map<Object, T> getRecords() {
                return Collections.emptyMap();
            }

            @Override
            public Set<String> getRecoveredSwapLocations() {
                return Collections.emptySet();
            }

            @Override
            public File getRecoveryFile() {
                return null;
            }
        };
    }
}
