package org.xbib.event.wal;

import java.io.File;
import java.util.Map;
import java.util.Set;

public class StandardSnapshotRecovery<T> implements SnapshotRecovery<T> {
    private final Map<Object, T> recordMap;
    private final Set<String> recoveredSwapLocations;
    private final File recoveryFile;
    private final long maxTransactionId;

    public StandardSnapshotRecovery(final Map<Object, T> recordMap, final Set<String> recoveredSwapLocations, final File recoveryFile, final long maxTransactionId) {
        this.recordMap = recordMap;
        this.recoveredSwapLocations = recoveredSwapLocations;
        this.recoveryFile = recoveryFile;
        this.maxTransactionId = maxTransactionId;
    }

    @Override
    public long getMaxTransactionId() {
        return maxTransactionId;
    }

    @Override
    public Map<Object, T> getRecords() {
        return recordMap;
    }

    @Override
    public Set<String> getRecoveredSwapLocations() {
        return recoveredSwapLocations;
    }

    @Override
    public File getRecoveryFile() {
        return recoveryFile;
    }
}
