package org.xbib.event.bus;

import java.util.ArrayList;
import java.util.List;
import static org.junit.jupiter.api.Assertions.fail;

/**
 * A simple EventSubscriber mock that records Strings.
 *
 * <p>For testing fun, also includes a landmine method that EventBus tests are required <em>not</em>
 * to call ({@link #methodWithoutAnnotation(String)}).
 *
 */
public class StringCatcher {

    private final List<String> events = new ArrayList<>();

    @Subscribe
    public void hereHaveAString(String string) {
        events.add(string);
    }

    public void methodWithoutAnnotation(String string) {
        fail("Event bus must not call methods without @Subscribe!");
    }

    public List<String> getEvents() {
        return events;
    }
}
